## org.hibernate.type
Class ComponentType

    java.lang.Object
      org.hibernate.type.AbstractType
          org.hibernate.type.ComponentType

All Implemented Interfaces:
  Serializable, CompositeType, Type

Direct Known Subclasses:
  EmbeddedComponentType

    public class ComponentType

extends AbstractType
implements CompositeType

Handles "component" mappings

See Also:
  Serialized Form

Field Summary
`protected ComponentTuplizer` `componentTuplizer`
`protected EntityMode` `entityMode`
`protected int` `propertySpan`

Fields inherited from class org.hibernate.type.AbstractType
`LEGACY_DEFAULT_SIZE, LEGACY_DICTATED_SIZE`

Constructor Summary
`ComponentType(TypeFactory.TypeScope typeScope, ComponentMetamodel metamodel)`

Method Summary
`Object` `assemble(Serializable object, SessionImplementor session, Object owner)` Reconstruct the object from its disassembled state.
`int` `compare(Object x, Object y)` Perform a `Comparator` style comparison between values
`Object` `deepCopy(Object component, SessionFactoryImplementor factory)` Return a deep copy of the persistent state, stopping at entities and at collections.
`Size[]` `defaultSizes(Mapping mapping)` Defines the column sizes to use according to this type if the user did not explicitly say (and if no `Type.dictatedSizes(org.hibernate.engine.spi.Mapping)` were given).
`Size[]` `dictatedSizes(Mapping mapping)` Return the column sizes dictated by this type.
`Serializable` `disassemble(Object value, SessionImplementor session, Object owner)` Return a disassembled representation of the object.
`Object` `fromXMLNode(org.dom4j.Node xml, Mapping factory)` Parse the XML representation of an instance.
`CascadeStyle` `getCascadeStyle(int i)` Retrieve the cascade style of the indicated component property.
`int` `getColumnSpan(Mapping mapping)` How many columns are used to persist this type.
`ComponentTuplizer` `getComponentTuplizer()`
`EntityMode` `getEntityMode()`
`FetchMode` `getFetchMode(int i)` Retrieve the fetch mode of the indicated component property.
`int` `getHashCode(Object x)` Get a hash code, consistent with persistence "equality".
`int` `getHashCode(Object x, SessionFactoryImplementor factory)` Get a hash code, consistent with persistence "equality".
`String` `getName()` Returns the abbreviated name of the type.
`int` `getPropertyIndex(String name)`
`String[]` `getPropertyNames()` Get the names of the component properties
`boolean[]` `getPropertyNullability()` Retrieve the indicators regarding which component properties are nullable.
`Object` `getPropertyValue(Object component, int i, EntityMode entityMode)`
`Object` `getPropertyValue(Object component, int i, SessionImplementor session)` Extract a particular component property value indicated by index.
`Object[]` `getPropertyValues(Object component, EntityMode entityMode)` Extract the values of the component properties from the given component instance without access to the session.
`Object[]` `getPropertyValues(Object component, SessionImplementor session)` Extract the values of the component properties from the given component instance
`Class` `getReturnedClass()` The class returned by `Type.nullSafeGet(java.sql.ResultSet, java.lang.String[], org.hibernate.engine.spi.SessionImplementor, java.lang.Object)` methods.
`Type[]` `getSubtypes()` Get the types of the component properties
`Object` `hydrate(ResultSet rs, String[] names, SessionImplementor session, Object owner)` Extract a value from the JDBC result set.
`Object` `instantiate(EntityMode entityMode)` This method does not populate the component parent
`Object` `instantiate(Object parent, SessionImplementor session)`
`boolean` `isComponentType()` Return true if the implementation is castable to `CompositeType`.
`boolean` `isDirty(Object x, Object y, boolean[] checkable, SessionImplementor session)` Should the parent be considered dirty, given both the old and current value?
`boolean` `isDirty(Object x, Object y, SessionImplementor session)` Should the parent be considered dirty, given both the old and current value?
`boolean` `isEmbedded()` Is this component embedded? "embedded" indicates that the component is "virtual", that its properties are "flattened" onto its owner
`boolean` `isEqual(Object x, Object y)` Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state).
`boolean` `isEqual(Object x, Object y, SessionFactoryImplementor factory)` Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state).
`boolean` `isKey()`
`boolean` `isMethodOf(Method method)` Is the given method a member of this component's class?
`boolean` `isModified(Object old, Object current, boolean[] checkable, SessionImplementor session)` Has the value been modified compared to the current database state? The difference between this and the `Type.isDirty(java.lang.Object, java.lang.Object, org.hibernate.engine.spi.SessionImplementor)` methods is that here we need to account for "partially" built values.
`boolean` `isMutable()` Are objects of this type mutable.
`boolean` `isSame(Object x, Object y)` Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state) taking a shortcut for entity references.
`boolean` `isXMLElement()`
`Object` `nullSafeGet(ResultSet rs, String[] names, SessionImplementor session, Object owner)` Extract a value of the `mapped class` from the JDBC result set.
`Object` `nullSafeGet(ResultSet rs, String name, SessionImplementor session, Object owner)` Extract a value of the `mapped class` from the JDBC result set.
`void` `nullSafeSet(PreparedStatement st, Object value, int begin, boolean[] settable, SessionImplementor session)` Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement, ignoring some columns as dictated by the 'settable' parameter.
`void` `nullSafeSet(PreparedStatement st, Object value, int begin, SessionImplementor session)` Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement.
`Object` `replace(Object original, Object target, SessionImplementor session, Object owner, Map copyCache)` During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging.
`Object` `replace(Object original, Object target, SessionImplementor session, Object owner, Map copyCache, ForeignKeyDirection foreignKeyDirection)` During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging.
`Object` `resolve(Object value, SessionImplementor session, Object owner)` The second phase of 2-phase loading.
`Object` `semiResolve(Object value, SessionImplementor session, Object owner)` Given a hydrated, but unresolved value, return a value that may be used to reconstruct property-ref associations.
`void` `setPropertyValues(Object component, Object[] values, EntityMode entityMode)` Inject property values onto the given component instance An optional operation
`void` `setToXMLNode(org.dom4j.Node node, Object value, SessionFactoryImplementor factory)` A representation of the value to be embedded in an XML element.
`int[]` `sqlTypes(Mapping mapping)` Return the JDBC types codes (per `Types`) for the columns mapped by this type.
`boolean[]` `toColumnNullness(Object value, Mapping mapping)` Given an instance of the type, return an array of boolean, indicating which mapped columns would be null.
`String` `toLoggableString(Object value, SessionFactoryImplementor factory)` Generate a representation of the value for logging purposes.

Methods inherited from class org.hibernate.type.AbstractType
`beforeAssemble, getSemiResolvedType, isAnyType, isAssociationType, isCollectionType, isEntityType, replaceNode`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.hibernate.type.Type
`beforeAssemble, getSemiResolvedType, isAnyType, isAssociationType, isCollectionType, isEntityType`

Field Detail

### propertySpan

    protected final int propertySpan

### entityMode

    protected final EntityMode entityMode

### componentTuplizer

    protected final ComponentTuplizer componentTuplizer

Constructor Detail

### ComponentType

    public ComponentType(TypeFactory.TypeScope typeScope,
                         ComponentMetamodel metamodel)

Method Detail

### isKey

    public boolean isKey()

### getEntityMode

    public EntityMode getEntityMode()

### getComponentTuplizer

    public ComponentTuplizer getComponentTuplizer()

### getColumnSpan

    public int getColumnSpan(Mapping mapping)
                      throws MappingException

  Description copied from interface: `Type`
  How many columns are used to persist this type. Always the same as `sqlTypes(mapping).length`

  Specified by:
    `getColumnSpan` in interface `Type`
  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The number of columns
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### sqlTypes

    public int[] sqlTypes(Mapping mapping)
                   throws MappingException

  Description copied from interface: `Type`
  Return the JDBC types codes (per `Types`) for the columns mapped by this type.

  NOTE: The number of elements in this array matches the return from `Type.getColumnSpan(org.hibernate.engine.spi.Mapping)`.

  Specified by:
    `sqlTypes` in interface `Type`
  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The JDBC type codes.
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### dictatedSizes

    public Size[] dictatedSizes(Mapping mapping)
                         throws MappingException

  Description copied from interface: `Type`
  Return the column sizes dictated by this type. For example, the mapping for a `char`/`Character` would have a dictated length limit of 1; for a string-based `UUID` would have a size limit of 36; etc.

  NOTE: The number of elements in this array matches the return from `Type.getColumnSpan(org.hibernate.engine.spi.Mapping)`.

  Specified by:
    `dictatedSizes` in interface `Type`
  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The dictated sizes.
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### defaultSizes

    public Size[] defaultSizes(Mapping mapping)
                        throws MappingException

  Description copied from interface: `Type`
  Defines the column sizes to use according to this type if the user did not explicitly say (and if no `Type.dictatedSizes(org.hibernate.engine.spi.Mapping)` were given).

  NOTE: The number of elements in this array matches the return from `Type.getColumnSpan(org.hibernate.engine.spi.Mapping)`.

  Specified by:
    `defaultSizes` in interface `Type`
  Parameters:
    `mapping` - The mapping object :/
  Returns:
    The default sizes.
  Throws:
    `MappingException` - Generally indicates an issue accessing the passed mapping object.

### isComponentType

    public final boolean isComponentType()

  Description copied from interface: `Type`
  Return true if the implementation is castable to `CompositeType`. Essentially a polymorphic version of `(type instanceof CompositeType.class)`. A component type may own collections or associations and hence must provide certain extra functionality.

  Specified by:
    `isComponentType` in interface `Type`
  Overrides:
    `isComponentType` in class `AbstractType`
  Returns:
    True if this type is also an `CompositeType` implementor; false otherwise.

### getReturnedClass

    public Class getReturnedClass()

  Description copied from interface: `Type`
  The class returned by `Type.nullSafeGet(java.sql.ResultSet, java.lang.String[], org.hibernate.engine.spi.SessionImplementor, java.lang.Object)` methods. This is used to establish the class of an array of this type.

  Specified by:
    `getReturnedClass` in interface `Type`
  Returns:
    The java type class handled by this type.

### isSame

    public boolean isSame(Object x,
                          Object y)
                   throws HibernateException

  Description copied from interface: `Type`
  Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state) taking a shortcut for entity references.

  For most types this should equate to an `equals` check on the values. For associations the implication is a bit different. For most types it is conceivable to simply delegate to `Type.isEqual(java.lang.Object, java.lang.Object)`

  Specified by:
    `isSame` in interface `Type`
  Overrides:
    `isSame` in class `AbstractType`
  Parameters:
    `x` - The first value
    `y` - The second value
  Returns:
    True if there are considered the same (see discussion above).
  Throws:
    `HibernateException` - A problem occurred performing the comparison

### isEqual

    public boolean isEqual(Object x,
                           Object y)
                    throws HibernateException

  Description copied from interface: `Type`
  Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state).

  This should always equate to some form of comparison of the value's internal state. As an example, for something like a date the comparison should be based on its internal "time" state based on the specific portion it is meant to represent (timestamp, date, time).

  Specified by:
    `isEqual` in interface `Type`
  Overrides:
    `isEqual` in class `AbstractType`
  Parameters:
    `x` - The first value
    `y` - The second value
  Returns:
    True if there are considered equal (see discussion above).
  Throws:
    `HibernateException` - A problem occurred performing the comparison

### isEqual

    public boolean isEqual(Object x,
                           Object y,
                           SessionFactoryImplementor factory)
                    throws HibernateException

  Description copied from interface: `Type`
  Compare two instances of the class mapped by this type for persistence "equality" (equality of persistent state).

  This should always equate to some form of comparison of the value's internal state. As an example, for something like a date the comparison should be based on its internal "time" state based on the specific portion it is meant to represent (timestamp, date, time).

  Specified by:
    `isEqual` in interface `Type`
  Overrides:
    `isEqual` in class `AbstractType`
  Parameters:
    `x` - The first value
    `y` - The second value
    `factory` - The session factory
  Returns:
    True if there are considered equal (see discussion above).
  Throws:
    `HibernateException` - A problem occurred performing the comparison

### compare

    public int compare(Object x,
                       Object y)

  Description copied from interface: `Type`
  Perform a `Comparator` style comparison between values

  Specified by:
    `compare` in interface `Type`
  Overrides:
    `compare` in class `AbstractType`
  Parameters:
    `x` - The first value
    `y` - The second value
  Returns:
    The comparison result. See `Comparator.compare(T, T)` for a discussion.

### isMethodOf

    public boolean isMethodOf(Method method)

  Description copied from interface: `CompositeType`
  Is the given method a member of this component's class?

  Specified by:
    `isMethodOf` in interface `CompositeType`
  Parameters:
    `method` - The method to check
  Returns:
    True if the method is a member; false otherwise.

### getHashCode

    public int getHashCode(Object x)

  Description copied from interface: `Type`
  Get a hash code, consistent with persistence "equality". Again for most types the normal usage is to delegate to the value's `hashCode`.

  Specified by:
    `getHashCode` in interface `Type`
  Overrides:
    `getHashCode` in class `AbstractType`
  Parameters:
    `x` - The value for which to retrieve a hash code
  Returns:
    The hash code

### getHashCode

    public int getHashCode(Object x,
                           SessionFactoryImplementor factory)

  Description copied from interface: `Type`
  Get a hash code, consistent with persistence "equality". Again for most types the normal usage is to delegate to the value's `hashCode`.

  Specified by:
    `getHashCode` in interface `Type`
  Overrides:
    `getHashCode` in class `AbstractType`
  Parameters:
    `x` - The value for which to retrieve a hash code
    `factory` - The session factory
  Returns:
    The hash code

### isDirty

    public boolean isDirty(Object x,
                           Object y,
                           SessionImplementor session)
                    throws HibernateException

  Description copied from interface: `Type`
  Should the parent be considered dirty, given both the old and current value?

  Specified by:
    `isDirty` in interface `Type`
  Overrides:
    `isDirty` in class `AbstractType`
  Parameters:
    `x` - the old value
    `y` - the current value
    `session` - The session from which the request originated.
  Returns:
    true if the field is dirty
  Throws:
    `HibernateException` - A problem occurred performing the checking

### isDirty

    public boolean isDirty(Object x,
                           Object y,
                           boolean[] checkable,
                           SessionImplementor session)
                    throws HibernateException

  Description copied from interface: `Type`
  Should the parent be considered dirty, given both the old and current value?

  Specified by:
    `isDirty` in interface `Type`
  Parameters:
    `x` - the old value
    `y` - the current value
    `checkable` - An array of booleans indicating which columns making up the value are actually checkable
    `session` - The session from which the request originated.
  Returns:
    true if the field is dirty
  Throws:
    `HibernateException` - A problem occurred performing the checking

### isModified

    public boolean isModified(Object old,
                              Object current,
                              boolean[] checkable,
                              SessionImplementor session)
                       throws HibernateException

  Description copied from interface: `Type`
  Has the value been modified compared to the current database state? The difference between this and the `Type.isDirty(java.lang.Object, java.lang.Object, org.hibernate.engine.spi.SessionImplementor)` methods is that here we need to account for "partially" built values. This is really only an issue with association types. For most type implementations it is enough to simply delegate to `Type.isDirty(java.lang.Object, java.lang.Object, org.hibernate.engine.spi.SessionImplementor)` here/

  Specified by:
    `isModified` in interface `Type`
  Overrides:
    `isModified` in class `AbstractType`
  Parameters:
    `old` - the database state, in a "hydrated" form, with identifiers unresolved
    `current` - the current state of the object
    `checkable` - which columns are actually updatable
    `session` - The session from which the request originated.
  Returns:
    true if the field has been modified
  Throws:
    `HibernateException` - A problem occurred performing the checking

### nullSafeGet

    public Object nullSafeGet(ResultSet rs,
                              String[] names,
                              SessionImplementor session,
                              Object owner)
                       throws HibernateException,
                              SQLException

  Description copied from interface: `Type`
  Extract a value of the `mapped class` from the JDBC result set. Implementors should handle possibility of null values.

  Specified by:
    `nullSafeGet` in interface `Type`
  Parameters:
    `rs` - The result set from which to extract value.
    `names` - the column names making up this type value (use to read from result set)
    `session` - The originating session
    `owner` - the parent entity
  Returns:
    The extracted value
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver
  See Also:
    `alternative, 2-phase property initialization`

### nullSafeSet

    public void nullSafeSet(PreparedStatement st,
                            Object value,
                            int begin,
                            SessionImplementor session)
                     throws HibernateException,
                            SQLException

  Description copied from interface: `Type`
  Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement. Implementors should handle possibility of null values. A multi-column type should bind parameters starting from `index`.

  Specified by:
    `nullSafeSet` in interface `Type`
  Parameters:
    `st` - The JDBC prepared statement to which to bind
    `value` - the object to write
    `begin` - starting parameter bind index
    `session` - The originating session
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver

### nullSafeSet

    public void nullSafeSet(PreparedStatement st,
                            Object value,
                            int begin,
                            boolean[] settable,
                            SessionImplementor session)
                     throws HibernateException,
                            SQLException

  Description copied from interface: `Type`
  Bind a value represented by an instance of the `mapped class` to the JDBC prepared statement, ignoring some columns as dictated by the 'settable' parameter. Implementors should handle the possibility of null values. A multi-column type should bind parameters starting from `index`.

  Specified by:
    `nullSafeSet` in interface `Type`
  Parameters:
    `st` - The JDBC prepared statement to which to bind
    `value` - the object to write
    `begin` - starting parameter bind index
    `settable` - an array indicating which columns to bind/ignore
    `session` - The originating session
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver

### nullSafeGet

    public Object nullSafeGet(ResultSet rs,
                              String name,
                              SessionImplementor session,
                              Object owner)
                       throws HibernateException,
                              SQLException

  Description copied from interface: `Type`
  Extract a value of the `mapped class` from the JDBC result set. Implementors should handle possibility of null values. This form might be called if the type is known to be a single-column type.

  Specified by:
    `nullSafeGet` in interface `Type`
  Parameters:
    `rs` - The result set from which to extract value.
    `name` - the column name making up this type value (use to read from result set)
    `session` - The originating session
    `owner` - the parent entity
  Returns:
    The extracted value
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver

### getPropertyValue

    public Object getPropertyValue(Object component,
                                   int i,
                                   SessionImplementor session)
                            throws HibernateException

  Description copied from interface: `CompositeType`
  Extract a particular component property value indicated by index.

  Specified by:
    `getPropertyValue` in interface `CompositeType`
  Parameters:
    `component` - The component instance
    `i` - The index of the property whose value is to be extracted
    `session` - The session from which the request originates.
  Returns:
    The extracted component property value
  Throws:
    `HibernateException` - Indicates a problem access the property value.

### getPropertyValue

    public Object getPropertyValue(Object component,
                                   int i,
                                   EntityMode entityMode)
                            throws HibernateException

  Throws:
    `HibernateException`

### getPropertyValues

    public Object[] getPropertyValues(Object component,
                                      SessionImplementor session)
                               throws HibernateException

  Description copied from interface: `CompositeType`
  Extract the values of the component properties from the given component instance

  Specified by:
    `getPropertyValues` in interface `CompositeType`
  Parameters:
    `component` - The component instance
    `session` - The session from which the request originates
  Returns:
    The property values
  Throws:
    `HibernateException` - Indicates a problem access the property values.

### getPropertyValues

    public Object[] getPropertyValues(Object component,
                                      EntityMode entityMode)
                               throws HibernateException

  Description copied from interface: `CompositeType`
  Extract the values of the component properties from the given component instance without access to the session.

  An optional operation

  Specified by:
    `getPropertyValues` in interface `CompositeType`
  Parameters:
    `component` - The component instance
    `entityMode` - The entity mode
  Returns:
    The property values
  Throws:
    `HibernateException` - Indicates a problem access the property values.

### setPropertyValues

    public void setPropertyValues(Object component,
                                  Object[] values,
                                  EntityMode entityMode)
                           throws HibernateException

  Description copied from interface: `CompositeType`
  Inject property values onto the given component instance

  An optional operation

  Specified by:
    `setPropertyValues` in interface `CompositeType`
  Parameters:
    `component` - The component instance
    `values` - The values to inject
    `entityMode` - The entity mode
  Throws:
    `HibernateException` - Indicates an issue performing the injection

### getSubtypes

    public Type[] getSubtypes()

  Description copied from interface: `CompositeType`
  Get the types of the component properties

  Specified by:
    `getSubtypes` in interface `CompositeType`
  Returns:
    The component property types.

### getName

    public String getName()

  Description copied from interface: `Type`
  Returns the abbreviated name of the type.

  Specified by:
    `getName` in interface `Type`
  Returns:
    String the Hibernate type name

### toLoggableString

    public String toLoggableString(Object value,
                                   SessionFactoryImplementor factory)
                            throws HibernateException

  Description copied from interface: `Type`
  Generate a representation of the value for logging purposes.

  Specified by:
    `toLoggableString` in interface `Type`
  Parameters:
    `value` - The value to be logged
    `factory` - The session factory
  Returns:
    The loggable representation
  Throws:
    `HibernateException` - An error from Hibernate

### getPropertyNames

    public String[] getPropertyNames()

  Description copied from interface: `CompositeType`
  Get the names of the component properties

  Specified by:
    `getPropertyNames` in interface `CompositeType`
  Returns:
    The component property names

### deepCopy

    public Object deepCopy(Object component,
                           SessionFactoryImplementor factory)
                    throws HibernateException

  Description copied from interface: `Type`
  Return a deep copy of the persistent state, stopping at entities and at collections.

  Specified by:
    `deepCopy` in interface `Type`
  Parameters:
    `component` - The value to be copied
    `factory` - The session factory
  Returns:
    The deep copy
  Throws:
    `HibernateException` - An error from Hibernate

### replace

    public Object replace(Object original,
                          Object target,
                          SessionImplementor session,
                          Object owner,
                          Map copyCache)
                   throws HibernateException

  Description copied from interface: `Type`
  During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging. For immutable objects, or null values, it is safe to simply return the first parameter. For mutable objects, it is safe to return a copy of the first parameter. For objects with component values, it might make sense to recursively replace component values.

  Specified by:
    `replace` in interface `Type`
  Parameters:
    `original` - the value from the detached entity being merged
    `target` - the value in the managed entity
    `session` - The originating session
    `owner` - The owner of the value
    `copyCache` - The cache of already copied/replaced values
  Returns:
    the value to be merged
  Throws:
    `HibernateException` - An error from Hibernate

### replace

    public Object replace(Object original,
                          Object target,
                          SessionImplementor session,
                          Object owner,
                          Map copyCache,
                          ForeignKeyDirection foreignKeyDirection)
                   throws HibernateException

  Description copied from interface: `Type`
  During merge, replace the existing (target) value in the entity we are merging to with a new (original) value from the detached entity we are merging. For immutable objects, or null values, it is safe to simply return the first parameter. For mutable objects, it is safe to return a copy of the first parameter. For objects with component values, it might make sense to recursively replace component values.

  Specified by:
    `replace` in interface `Type`
  Overrides:
    `replace` in class `AbstractType`
  Parameters:
    `original` - the value from the detached entity being merged
    `target` - the value in the managed entity
    `session` - The originating session
    `owner` - The owner of the value
    `copyCache` - The cache of already copied/replaced values
    `foreignKeyDirection` - For associations, which direction does the foreign key point?
  Returns:
    the value to be merged
  Throws:
    `HibernateException` - An error from Hibernate

### instantiate

    public Object instantiate(EntityMode entityMode)
                       throws HibernateException

  This method does not populate the component parent

  Throws:
    `HibernateException`

### instantiate

    public Object instantiate(Object parent,
                              SessionImplementor session)
                       throws HibernateException

  Throws:
    `HibernateException`

### getCascadeStyle

    public CascadeStyle getCascadeStyle(int i)

  Description copied from interface: `CompositeType`
  Retrieve the cascade style of the indicated component property.

  Specified by:
    `getCascadeStyle` in interface `CompositeType`
  Parameters:
    `i` - The property index,
  Returns:
    The cascade style.

### isMutable

    public boolean isMutable()

  Description copied from interface: `Type`
  Are objects of this type mutable. (With respect to the referencing object ... entities and collections are considered immutable because they manage their own internal state.)

  Specified by:
    `isMutable` in interface `Type`
  Returns:
    boolean

### disassemble

    public Serializable disassemble(Object value,
                                    SessionImplementor session,
                                    Object owner)
                             throws HibernateException

  Description copied from interface: `Type`
  Return a disassembled representation of the object. This is the value Hibernate will use in second level caching, so care should be taken to break values down to their simplest forms; for entities especially, this means breaking them down into their constituent parts.

  Specified by:
    `disassemble` in interface `Type`
  Overrides:
    `disassemble` in class `AbstractType`
  Parameters:
    `value` - the value to cache
    `session` - the originating session
    `owner` - optional parent entity object (needed for collections)
  Returns:
    the disassembled, deep cloned state
  Throws:
    `HibernateException` - An error from Hibernate

### assemble

    public Object assemble(Serializable object,
                           SessionImplementor session,
                           Object owner)
                    throws HibernateException

  Description copied from interface: `Type`
  Reconstruct the object from its disassembled state. This method is the reciprocal of `Type.disassemble(java.lang.Object, org.hibernate.engine.spi.SessionImplementor, java.lang.Object)`

  Specified by:
    `assemble` in interface `Type`
  Overrides:
    `assemble` in class `AbstractType`
  Parameters:
    `object` - the disassembled state from the cache
    `session` - the originating session
    `owner` - the parent entity object
  Returns:
    the (re)assembled object
  Throws:
    `HibernateException` - An error from Hibernate

### getFetchMode

    public FetchMode getFetchMode(int i)

  Description copied from interface: `CompositeType`
  Retrieve the fetch mode of the indicated component property.

  Specified by:
    `getFetchMode` in interface `CompositeType`
  Parameters:
    `i` - The property index,
  Returns:
    The fetch mode

### hydrate

    public Object hydrate(ResultSet rs,
                          String[] names,
                          SessionImplementor session,
                          Object owner)
                   throws HibernateException,
                          SQLException

  Description copied from interface: `Type`
  Extract a value from the JDBC result set. This is useful for 2-phase property initialization - the second phase is a call to `Type.resolve(java.lang.Object, org.hibernate.engine.spi.SessionImplementor, java.lang.Object)` This hydrated value will be either:
  - in the case of an entity or collection type, the key
  - otherwise, the value itself

  Specified by:
    `hydrate` in interface `Type`
  Overrides:
    `hydrate` in class `AbstractType`
  Parameters:
    `rs` - The JDBC result set
    `names` - the column names making up this type value (use to read from result set)
    `session` - The originating session
    `owner` - the parent entity
  Returns:
    An entity or collection key, or an actual value.
  Throws:
    `HibernateException` - An error from Hibernate
    `SQLException` - An error from the JDBC driver
  See Also:
    `Type.resolve(java.lang.Object, org.hibernate.engine.spi.SessionImplementor, java.lang.Object)`

### resolve

    public Object resolve(Object value,
                          SessionImplementor session,
                          Object owner)
                   throws HibernateException

  Description copied from interface: `Type`
  The second phase of 2-phase loading. Only really pertinent for entities and collections. Here we resolve the identifier to an entity or collection instance

  Specified by:
    `resolve` in interface `Type`
  Overrides:
    `resolve` in class `AbstractType`
  Parameters:
    `value` - an identifier or value returned by `hydrate()`
    `session` - the session
    `owner` - the parent entity
  Returns:
    the given value, or the value associated with the identifier
  Throws:
    `HibernateException` - An error from Hibernate
  See Also:
    `Type.hydrate(java.sql.ResultSet, java.lang.String[], org.hibernate.engine.spi.SessionImplementor, java.lang.Object)`

### semiResolve

    public Object semiResolve(Object value,
                              SessionImplementor session,
                              Object owner)
                       throws HibernateException

  Description copied from interface: `Type`
  Given a hydrated, but unresolved value, return a value that may be used to reconstruct property-ref associations.

  Specified by:
    `semiResolve` in interface `Type`
  Overrides:
    `semiResolve` in class `AbstractType`
  Parameters:
    `value` - The unresolved, hydrated value
    `session` - THe originating session
    `owner` - The value owner
  Returns:
    The semi-resolved value
  Throws:
    `HibernateException` - An error from Hibernate

### getPropertyNullability

    public boolean[] getPropertyNullability()

  Description copied from interface: `CompositeType`
  Retrieve the indicators regarding which component properties are nullable.

  An optional operation

  Specified by:
    `getPropertyNullability` in interface `CompositeType`
  Returns:
    nullability of component properties

### isXMLElement

    public boolean isXMLElement()

  Specified by:
    `isXMLElement` in interface `Type`
  Overrides:
    `isXMLElement` in class `AbstractType`

### fromXMLNode

    public Object fromXMLNode(org.dom4j.Node xml,
                              Mapping factory)
                       throws HibernateException

  Description copied from interface: `Type`
  Parse the XML representation of an instance.

  Specified by:
    `fromXMLNode` in interface `Type`
  Parameters:
    `xml` - The XML node from which to read the value
    `factory` - The session factory
  Returns:
    an instance of the `mapped class`
  Throws:
    `HibernateException` - An error from Hibernate

### setToXMLNode

    public void setToXMLNode(org.dom4j.Node node,
                             Object value,
                             SessionFactoryImplementor factory)
                      throws HibernateException

  Description copied from interface: `Type`
  A representation of the value to be embedded in an XML element.

  Specified by:
    `setToXMLNode` in interface `Type`
  Parameters:
    `node` - The XML node to which to write the value
    `value` - The value to write
    `factory` - The session factory
  Throws:
    `HibernateException` - An error from Hibernate

### toColumnNullness

    public boolean[] toColumnNullness(Object value,
                                      Mapping mapping)

  Description copied from interface: `Type`
  Given an instance of the type, return an array of boolean, indicating which mapped columns would be null.

  Specified by:
    `toColumnNullness` in interface `Type`
  Parameters:
    `value` - an instance of the type
    `mapping` - The mapping abstraction
  Returns:
    array indicating column nullness for a value instance

### isEmbedded

    public boolean isEmbedded()

  Description copied from interface: `CompositeType`
  Is this component embedded? "embedded" indicates that the component is "virtual", that its properties are "flattened" onto its owner

  Specified by:
    `isEmbedded` in interface `CompositeType`
  Returns:
    True if this component is embedded; false otherwise.

### getPropertyIndex

    public int getPropertyIndex(String name)

Copyright © 2001-2012 Red Hat, Inc. All Rights Reserved.